/// Files: drivers/block/floppy.c
/// Fix: ef87dbe7614341c2e7bfe8d32fcb7028cc97442c
/// Detect-To: v2.6.12-rc2

virtual detect

@err exists@
type T1, T2;
identifier ret, ptr, param, rcmd;
position p;
@@

raw_cmd_copyin(..., struct floppy_raw_cmd **rcmd)
{
	...
	ptr = (T1)kmalloc(...);
	...
	*rcmd = ptr;
	...
(
*	ret = copy_from_user@p(ptr, (T2)param, sizeof(*ptr));
|
*	COPYIN@p(*ptr);
)
	... when != ptr->kernel_data = NULL;
	    when any
(
	if (ret)
		return -EFAULT;
|
	if (ptr->cmd_count > 33)
		return -EINVAL;
)
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2014-1737')
