/// Files: arch/x86/kvm/emulate.c
/// Fix: 3f6f1480d86bf9fc16c160d803ab1d006e3058d5
/// Fixes: 41061cdb98a0bec464278b4db8e894a3121671f5

virtual detect

@rip_relative@
identifier ctxt;
@@

x86_decode_insn(struct x86_emulate_ctxt *ctxt, ...)
{
	...
*	if (ctxt->rip_relative)
*		ctxt->memopp->addr.mem.ea += ctxt->_eip;
	...
}

@err_pfx_0f_ae_7 depends on rip_relative exists@
symbol pfx_0f_ae_7, em_clflush;
position p;
@@

struct gprefix pfx_0f_ae_7 = {
*	I(0, em_clflush)@p,
	...
};

@err_twobyte_table depends on rip_relative exists@
symbol twobyte_table, ImplicitOps, ModRM;
position p;
@@

struct opcode twobyte_table[...] = {
	...,
*	D(ImplicitOps | ModRM)@p,
	...
};


@script:python depends on detect@
p << err_pfx_0f_ae_7.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2014-8480')

@script:python depends on detect@
p << err_twobyte_table.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2014-8480')
