/// Files: fs/nfs/nfs4proc.c
/// Fix: 18e3b739fdc826481c6a1335ce0c5b19b3d415da
/// Fixes: ec011fe847347b40c60fdb5085f65227762e2e08
/// Version: 1.0.7

virtual detect

@ops@
symbol nfs41_mig_recovery_ops;
@@

struct nfs4_mig_recovery_ops nfs41_mig_recovery_ops = ...;

@fix@
symbol nfs_v4_2_minor_ops, nfs41_mig_recovery_ops;
@@

struct nfs4_minor_version_ops nfs_v4_2_minor_ops = {
	...,
	.mig_recovery_ops = &nfs41_mig_recovery_ops,
	...
};

@err depends on !fix && ops@
symbol nfs_v4_2_minor_ops;
position p;
@@

struct nfs4_minor_version_ops nfs_v4_2_minor_ops =@p {
	...
};

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2015-8746')
