/// Files: net/ipv4/tcp_input.c
/// Fix: 8b8a321ff72c785ed5e8b4cf6eda20b35d427390
/// Fixes: 3759824da87b30ce7a35b4873b62b0ba38905ef5

virtual detect

@err exists@
identifier tp, prior_unsacked, fast_rexmit, flag;
position p;
@@

tcp_cwnd_reduction(..., const int prior_unsacked, int fast_rexmit, int flag)
{
	...
	int newly_acked_sacked = prior_unsacked -
				 (tp->packets_out - tp->sacked_out);
	... when != if (newly_acked_sacked <= 0 || WARN_ON_ONCE(!tp->prior_cwnd)) return;
*	tp->prr_delivered +=@p newly_acked_sacked;
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-2070')
