/// Files: drivers/net/ethernet/atheros/atlx/atl2.c net/ipv4/af_inet.c net/ipv6/ip6_offload.c
/// Fix: f43bfaeddc79effbf3d0fcb53ca477cca66f3db8
/// Fixes: ec5f061564238892005257c83565a0b58ec79295

virtual detect

@sg_feature exists@
identifier features;
@@

\(inet_gso_segment\|ipv6_gso_segment\)(..., netdev_features_t features)
{
	...
*	features &= ~NETIF_F_SG;
	...
}

@err depends on !sg_feature exists@
identifier netdev;
position p;
@@

atl2_probe(...)
{
	...
*	netdev->hw_features = NETIF_F_SG@p | \(NETIF_F_HW_VLAN_CTAG_RX\|NETIF_F_HW_VLAN_RX\);
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-2117')
