/// Files: mm/gup.c mm/memory.c mm/madvise.c
/// Fix: 19be0eaffa3ac7d8eb6784ad9bdbc7d67ed8e619
/// Fixes: 0a27a14a62921b438bb6f33772690d345a089be6

virtual detect

@madvise exists@
@@

madvise_need_mmap_write(...)
{
	...
}

@err_follow_page_pte depends on madvise exists@
identifier flags;
position p;
statement S;
@@

\(follow_page_pte\|follow_page_mask\|follow_page\)(..., unsigned int flags, ...)
{
	...
*	if ((flags & FOLL_WRITE) &&@p !pte_write(...)) S
	...
}

@err_faultin_page depends on madvise exists@
identifier ret, vma, flags;
position p;
@@

\(faultin_page\|__get_user_pages\|get_user_pages\)(...)
{
	...
	if ((ret & VM_FAULT_WRITE) && !(vma->vm_flags & VM_WRITE))
*		*flags &=@p ~FOLL_WRITE;
	...
}

@script:python depends on detect@
p << err_follow_page_pte.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-5195')

@script:python depends on detect@
p << err_faultin_page.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-5195')
