/// Files: include/net/tcp.h net/ipv4/tcp_output.c
/// Fix: bb1fceca22492109be12640d49f5ea5a544c6bb4
/// Fixes: 6859d49475d4f32abe640372117e4b687906e6b6

virtual detect

@sack_seq exists@
identifier tp;
@@

tcp_highest_sack_seq(struct tcp_sock *tp)
{
	...
	if (tp->highest_sack == NULL)
		return tp->snd_nxt;
	...
}

@sack_usage depends on sack_seq exists@
identifier sk, tp;
@@

tcp_xmit_retransmit_queue(struct sock *sk)
{
	...
	tp = tcp_sk(sk)
	... when any
*	tcp_highest_sack_seq(tp)
	...
}

@err depends on sack_usage exists@
identifier sk;
position p;
@@

tcp_check_send_head(struct sock *sk, ...)
{
*	if (sk->sk_send_head == skb_unlinked)
*		sk->sk_send_head =@p NULL;
	... when != if (tcp_sk(sk)->highest_sack == skb_unlinked) tcp_sk(sk)->highest_sack = NULL;
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-6828')
