/// Files: net/core/sock.c
/// Fix: b98b0bc8c431e3ceb4b26b0dfc8db509518fb290
/// Fixes: 82981930125abfd39d7c8378a9cfdf5e1be2002b
/// Version: 1.1.0

virtual detect

@err_set_sndbuf exists@
position p;
symbol u32;
@@

sock_setsockopt(...)
{
	...
set_sndbuf:
	sk->sk_userlocks |= SOCK_SNDBUF_LOCK;
*	sk->sk_sndbuf =@p max_t(u32, ..., SOCK_MIN_SNDBUF);
	...
}

@err_set_rcvbuf exists@
position p;
symbol u32;
@@

sock_setsockopt(...)
{
	...
set_rcvbuf:
	sk->sk_userlocks |= SOCK_RCVBUF_LOCK;
*	sk->sk_rcvbuf =@p max_t(u32, ..., SOCK_MIN_RCVBUF);
	...
}

@script:python depends on detect@
p << err_set_sndbuf.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-9793')

@script:python depends on detect@
p << err_set_rcvbuf.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2016-9793')
