/// Files: net/wireless/nl80211.c include/linux/nl80211.h include/uapi/linux/nl80211.h
/// Fix: 8feb69c7bd89513be80eb19198d48f154b254021
/// Fixes: 3b1c5a5307fb5277f395efdcf330c064d79df07d

virtual detect

@fix1@
@@

struct nla_policy nl80211_policy[...] = {
	...,
	[NL80211_ATTR_LOCAL_MESH_POWER_MODE] = NLA_POLICY_RANGE(...),
	...
};

@fix2@
@@

struct nla_policy nl80211_policy[...] = {
	...,
	[NL80211_ATTR_LOCAL_MESH_POWER_MODE] = { ... },
	...
};

@enum_attr@
@@

enum nl80211_attrs {
	...,
*	NL80211_ATTR_LOCAL_MESH_POWER_MODE,
	...
};

@err depends on enum_attr && (!fix1 && !fix2)@
position p;
@@

* struct nla_policy nl80211_policy@p[...] = {
	...
};

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-11089')
