/// Files: drivers/usb/usbip/stub_rx.c drivers/staging/usbip/stub_rx.c
/// Fix: 635f545a7e8be7596b9b2b6a43cab6bbd5a88e43
/// Fixes: 4d7b5c7f8ad49b7f01fb8aed83c560ac43cfbda8

virtual detect

@fix_get_pipe_pdu exists@
identifier epnum, pdu, err_ret;
@@

get_pipe(..., struct usbip_header *pdu)
{
	...
	int epnum = pdu->base.ep;
	...
	if (epnum < 0 || epnum > 15)
		goto err_ret;
	...
}

@fix_get_pipe_epnum exists@
identifier epnum, dir, err_ret;
@@

get_pipe(..., int epnum, int dir)
{
	...
	if (epnum < 0 || epnum > 15)
		goto err_ret;
	...
}

@err_pdu depends on !fix_get_pipe_pdu exists@
identifier pdu;
position p;
@@

* get_pipe@p(..., struct usbip_header *pdu)
{
	...
}

@err_epnum depends on !fix_get_pipe_epnum exists@
identifier epnum, dir;
position p;
@@

* get_pipe@p(..., int epnum, int dir)
{
	...
}

@script:python depends on detect@
p << err_pdu.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-16912')

@script:python depends on detect@
p << err_epnum.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-16912')
