/// Files: kernel/fork.c
/// Fix: 2b7e8665b4ff51c034c55df3cff76518d1a9ee3a
/// Fixes: 7c051267931a9be9c6620cc17b362bc6ee6dedc8

virtual detect

@dup_mmap@
identifier mm, oldmm, fail_uprobe_end;
@@

dup_mmap(struct mm_struct *mm, struct mm_struct *oldmm)
{
	...
*	if (down_write_killable(&oldmm->mmap_sem)) {
		...
*		goto fail_uprobe_end;
	}
	...
*	RCU_INIT_POINTER(mm->exe_file, get_mm_exe_file(oldmm));
	...
fail_uprobe_end:
	...
}

@err depends on dup_mmap@
identifier mm;
position p;
@@

mm_init(struct mm_struct *mm, ...)
{
	... when != RCU_INIT_POINTER(mm->exe_file, NULL);
*	mmu_notifier_mm_init@p(mm);
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-17052')
