/// Files: net/sctp/sctp_diag.c	net/sctp/socket.c
/// Fix: ee6c88bb754e3d363e568da78086adfedb692447
/// Detect-To: 52c52a61a39fb319c14a582f8631619e5d5f55bf

virtual detect

@err_inet_diag_msg_sctpladdrs_fill exists@
identifier info, laddr, addrlen;
position p;
@@

inet_diag_msg_sctpladdrs_fill(...)
{
	...
*	memcpy@p(info, &laddr->a, addrlen);
*	info += addrlen;
	...
}

@err_inet_diag_msg_sctpaddrs_fill exists@
identifier info, from, addrlen;
position p;
@@

inet_diag_msg_sctpaddrs_fill(...)
{
	...
*	memcpy@p(info, &from->ipaddr, addrlen);
*	info += addrlen;
	...
}

@err_sctp_get_sctp_info exists@
identifier info, prim;
position p;
@@

sctp_get_sctp_info(...)
{
	...
	memcpy(&info->sctpi_p_address, &prim->ipaddr,
*		sizeof@p(struct sockaddr_storage));
	...
}

@script:python depends on detect@
p << err_inet_diag_msg_sctpladdrs_fill.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-7558')

@script:python depends on detect@
p << err_inet_diag_msg_sctpaddrs_fill.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-7558')

@script:python depends on detect@
p << err_sctp_get_sctp_info.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2017-7558')
