/// Files: fs/f2fs/super.c fs/f2fs/segment.c
/// Fix: 42bf546c1fe3f3654bdf914e977acbc2b80a5be5
/// Fixes: 351df4b201157351c7d26bf12c3eeb9dbce98854

virtual detect

@divide@
identifier sbi;
@@

(
  GET_ZONE_FROM_SEG(sbi, ...)
|
  GET_ZONENO_FROM_SEGNO(sbi, ...)
|
  ... / sbi->secs_per_zone
)

@err depends on divide exists@
position p;
@@

* sanity_check_raw_super@p(...)
{
	... when != !secs_per_zone
	return 0;
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2018-13100')
