/// Files: drivers/infiniband/hw/mlx5/qp.c include/uapi/rdma/mlx5-abi.h drivers/infiniband/hw/mlx5/user.h
/// Fix: 0625b4ba1a5d4703c7fb01c497bd6c156908af00
/// Fixes: 41d902cb7c326d711674977763c4b30df87611bc

virtual detect

@struct_fields@
identifier reserved;
typedef __u32;
position p;
@@

struct mlx5_ib_create_qp_resp {
	__u32 bfreg_index;
	...
*	__u32 reserved;@p
	...
};

@err depends on struct_fields disable decl_init exists@
identifier resp;
position p;
@@

create_qp_common(...)
{
	...
*	struct mlx5_ib_create_qp_resp resp;@p
	... when != memset(&resp, 0, \(sizeof(resp)\|sizeof(struct mlx5_ib_create_qp_resp)\))
	    when != memzero_explicit(&resp, \(sizeof(resp)\|sizeof(struct mlx5_ib_create_qp_resp)\))
	create_user_qp(..., &resp, ...)
	...
}

@script:python depends on detect@
ps << struct_fields.p;
pf << err.p;
@@

coccilib.report.print_report(pf[0], 'ERROR: CVE-2018-20855')
coccilib.report.print_report(ps[0], 'ERROR: CVE-2018-20855')
