/// Files: fs/xfs/xfs_iops.c
/// Fix: 1fb254aa983bf190cfd685d40c64a480a9bafaee
/// Fixes: 253f4911f297b83745938b7f2c5649b94730b002
/// Version: 1.1.0

virtual detect

@err exists@
identifier ip, tp, out_cancel;
position p;
@@

xfs_setattr_nonsize(struct xfs_inode *ip, ...)
{
	...
*	xfs_ilock(ip, XFS_ILOCK_EXCL);
	...
*	goto out_cancel;
	...
out_cancel:@p
	xfs_trans_cancel(tp);
	... when != xfs_iunlock(ip, XFS_ILOCK_EXCL);
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-15538')
