/// Files: fs/cifs/smb2pdu.c
/// Fix: b57a55e2200ede754e4dc9cce4ba9402544b9365
/// Fixes: 9764c02fcbad40001fd3f63558d918e4d519bb75

virtual detect

@err_smb21_values exists@
identifier rsp, ses;
position p;
@@

SMB2_negotiate(...)
{
	... when any
	if (rsp->DialectRevision == cpu_to_le16(SMB21_PROT_ID)) {
* 		ses->server->ops =@p &smb21_operations;
		... when != ses->server->vals = &smb21_values;
	}
	...
}

@err_smb311_values exists@
identifier rsp, ses;
position p;
@@

SMB2_negotiate(...)
{
	... when any
	if (rsp->DialectRevision == cpu_to_le16(SMB311_PROT_ID)) {
* 		ses->server->ops =@p &smb311_operations;
		... when != ses->server->vals = &smb311_values;
	}
	...
}

@script:python depends on detect@
p << err_smb21_values.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-15918')

@script:python depends on detect@
p << err_smb311_values.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-15918')
