/// Files: drivers/android/binder.c
/// Fix: a56587065094fd96eb4c2b5ad65571daad32156d
/// Fixes: ec74136ded792deed80780a2f8baf3521eeb72f9
/// Version: 1.1.0

virtual detect

@err exists@
identifier added_size;
position p;
typedef binder_size_t;
typedef u64;
@@

binder_transaction(..., binder_size_t extra_buffers_size)
{
	... when any
(
	extra_buffers_size += ALIGN(secctx_sz, sizeof(u64));
|
	added_size = ALIGN(secctx_sz, sizeof(u64));
	extra_buffers_size += added_size;
)
	... when any
(
*	sg_buf_end_offset =@p sg_buf_offset + extra_buffers_size;
|
*	sg_buf_end =@p sg_bufp + extra_buffers_size;
)
	... when any
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-2214')
