/// Files: arch/s390/lib/uaccess.c arch/s390/mm/pgalloc.c
/// Fix: 316ec154810960052d4586b634156c54d0778f74
/// Fixes: 0aaba41b58bc5f3074c0c0a6136b9500b5e29e19
/// Version: 1.0.7

virtual detect

@err_enable_sacf_uaccess exists@
symbol current;
position p;
@@

enable_sacf_uaccess(void)
{
	... when != local_irq_save(...);
*	current@p->thread.mm_segment |= 1;
	...
}

@err___crst_table_upgrade exists@
symbol current;
identifier mm;
position p;
@@

__crst_table_upgrade(...)
{
	...
	if (current->active_mm == mm)
*		set_user_asce@p(mm);
	__tlb_flush_local();
	...
}

@script:python depends on detect@
p << err___crst_table_upgrade.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2020-11884')

@script:python depends on detect@
p << err_enable_sacf_uaccess.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2020-11884')
