/// Files: drivers/usb/misc/usbtest.c
/// Fix: 28ebeb8db77035e058a510ce9bd17c2b9a009dba
/// Fixes: v2.6.12-rc2

virtual detect

@buf_alloc exists@
identifier dev, intf;
@@

usbtest_probe(struct usb_interface *intf, ...)
{
	...
	dev->intf = intf;
	...
	dev->buf = kmalloc(...)
	...
}

@err depends on buf_alloc exists@
identifier dev;
position p;
@@

* usbtest_disconnect@p(...)
{
	... when != kfree(dev->buf);
	kfree(dev);
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2020-15393')
