/// Files: net/dccp/minisocks.c net/dccp/proto.c
/// Fix: d9ea761fdd197351890418acd462c51f241014a7
/// Fixes: 2677d20677314101293e6da0094ede7b5526d2b1

virtual detect

@disconnect exists@
identifier sk;
@@

dccp_disconnect(struct sock *sk, ...)
{
	...
	dccp_clear_xmit_timers(sk);
	... when != dp->dccps_hc_tx_ccid = NULL;
*	__skb_queue_purge(&sk->sk_receive_queue);
	...
}

@err depends on disconnect exists@
identifier newdp;
position p;
@@

dccp_create_openreq_child(...)
{
	...
*	newdp->dccps_role =@p DCCP_ROLE_SERVER;
	... when != newdp->dccps_hc_tx_ccid = NULL;
	INIT_LIST_HEAD(&newdp->dccps_featneg);
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2020-16119')
