/// Files: drivers/accessibility/speakup/spk_ttyio.c drivers/staging/speakup/spk_ttyio.c
/// Fix: d4122754442799187d5d537a9c039a49a67e57f1
/// Detect-To: 6b9ad1c742bf227b1005a41d8baa315b747e3e8d

virtual detect

@close exists@
@@

spk_ttyio_ldisc_close(...)
{
	...
	kfree(speakup_tty->disc_data);
	...
}

@err depends on close exists@
position p;
@@

spk_ttyio_ldisc_open(...)
{
	... when != mutex_lock(...);
*	speakup_tty = tty;
	...
*	speakup_tty->disc_data = ldisc_data;@p
	... when != mutex_unlock(...);
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], "ERROR: CVE-2020-28941")
