/// Files: net/can/bcm.c
/// Fix: 5e87ddbe3942e27e939bdc02deb8579b0cbd8ecc
/// Fixes: ffd980f976e7fd666c2e61bf8ab35107efd11828

virtual detect

@err_bcm_tx_timeout_handler exists@
identifier msg_head;
position p;
@@

\(bcm_tx_timeout_handler\|bcm_tx_timeout_tsklet\)(...)
{
	//struct bcm_msg_head msg_head;
	... when != memset(&msg_head, 0, sizeof(msg_head));
*	bcm_send_to_user@p(..., &msg_head, ...);
	...
}

@err_bcm_rx_changed exists@
identifier head;
position p;
@@

bcm_rx_changed(...)
{
	struct bcm_msg_head head;
	... when != memset(&head, 0, sizeof(head));
*	bcm_send_to_user@p(..., &head, ...);
	...
}

@err_bcm_rx_timeout_handler exists@
identifier msg_head;
position p;
@@

bcm_rx_timeout_handler(...)
{
	//struct bcm_msg_head msg_head;
	... when != memset(&msg_head, 0, sizeof(msg_head));
*	bcm_send_to_user@p(..., &msg_head, ...);
	...
}

@script:python depends on detect@
p << err_bcm_tx_timeout_handler.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-34693')

@script:python depends on detect@
p << err_bcm_rx_changed.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-34693')

@script:python depends on detect@
p << err_bcm_rx_timeout_handler.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-34693')
