/// Files: drivers/firewire/nosy.c
/// Fix: 829933ef05a951c8ff140e814656d73e74915faf
/// Detect-To: 286468210d83ce0ca1e37e346ed9f4457a161650

virtual detect

@err_nosy_start_snoop exists@
identifier client;
position p;
@@

nosy_start_snoop(struct client *client)
{
	...
	\(spin_lock_irq\|spin_lock_irqsave\)(...);
*	list_add_tail@p(&client->link, &client->lynx->client_list);
	\(spin_unlock_irq\|spin_unlock_irqrestore\)(...);
	...
}

@err_nosy_ioctl exists@
identifier client;
position p;
@@

	switch (...) {
	case NOSY_IOC_START:
		... when any
		spin_lock_irq(...);
*		list_add_tail@p(&client->link, &client->lynx->client_list);
		spin_unlock_irq(...);
		... when any
	}

@script:python depends on detect@
p << err_nosy_ioctl.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-3483')

@script:python depends on detect@
p << err_nosy_start_snoop.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-3483')
