/// Files: net/nfc/llcp_sock.c net/nfc/llcp/sock.c
/// Fix: 4ac06a1e013cf5fdd963317ffd3b968560f33bba
/// Fixes: d646960f7986fefb460a2b062d5ccc8ccfeacc3a
/// Version: 1.0.7

virtual detect

@err_service_name exists@
symbol llcp_sock, put_dev;
position p;
@@

llcp_sock_bind(...)
{
	...
*	if (!llcp_sock->service_name) {
		... when != llcp_sock->dev = NULL;
*		goto put_dev;@p
	}
	...
}

@err_ssap@
symbol llcp_sock, put_dev;
position p;
@@

llcp_sock_bind(...)
{
	...
*	if (llcp_sock->ssap == \(LLCP_SAP_MAX\|LLCP_MAX_SAP\)) {
		... when != llcp_sock->dev = NULL;
*		goto put_dev;@p
	}
	...
}

@script:python depends on detect@
p << err_service_name.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-38208')

@script:python depends on detect@
p << err_ssap.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-38208')
