/// Files: net/netfilter/nf_conntrack_standalone.c
/// Fix: 2671fa4dc0109d3fb581bc3078fdf17b5d9080f6
/// Fixes: d0febd81ae77a0e13717f1412ff9589e43fc4f8b
/// Version: 1.0.7

virtual detect

@err_NF_SYSCTL_CT_MAX exists@
identifier table, net;
symbol init_user_ns;
position p;
statement S;
@@

nf_conntrack_standalone_init_sysctl(struct net *net)
{
	...
*	if (net->user_ns != &init_user_ns) {
		...
*		table[NF_SYSCTL_CT_MAX].mode =@p 0444;
		...
	} else S
	...
}

@err_NF_SYSCTL_CT_EXPECT_MAX exists@
identifier table, net;
symbol init_user_ns;
position p;
statement S;
@@

nf_conntrack_standalone_init_sysctl(struct net *net)
{
	...
*	if (net->user_ns != &init_user_ns) {
		...
*		table[NF_SYSCTL_CT_EXPECT_MAX].mode =@p 0444;
		...
	} else S
	...
}

@err_NF_SYSCTL_CT_BUCKETS exists@
identifier table, net;
symbol init_user_ns;
position p;
statement S;
@@

nf_conntrack_standalone_init_sysctl(struct net *net)
{
	...
*	if (net->user_ns != &init_user_ns) {
		...
*		table[NF_SYSCTL_CT_BUCKETS].mode =@p 0444;
		...
	} else S
	...
}

@script:python depends on detect@
p << err_NF_SYSCTL_CT_MAX.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-38209')

@script:python depends on detect@
p << err_NF_SYSCTL_CT_EXPECT_MAX.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-38209')

@script:python depends on detect@
p << err_NF_SYSCTL_CT_BUCKETS.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-38209')
