/// Files: fs/xfs/xfs_ioctl.c fs/xfs/xfs_vnodeops.c
/// Fix: 983d8e60f50806f90534cc5373d0ce867e5aaf79
/// Detect-To: v2.6.12-rc2

virtual detect

@err exists@
identifier ip, bf, startoffset, fsize;
position p;
@@

\(xfs_ioc_space\|xfs_change_file_space\)(...)
{
	...
(
	if (bf->l_start > XFS_ISIZE(ip)) {
		...
		xfs_alloc_file_space(ip, XFS_ISIZE(ip),
				     bf->l_start - XFS_ISIZE(ip),
*				     0@p)
		...
 	}
|
	if (startoffset > fsize) {
		...
		xfs_alloc_file_space(ip, fsize,
				     startoffset - fsize,
*				     0@p,
				     ...)
		...
	}
)
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-4155')
