/// Files: net/rds/connection.c
/// Fix: 5f9562ebe710c307adc5f666bf1a2162ee7977c0
/// Fixes: aced3ce57cd37b5ca332bcacd370d01f5a8c5371

virtual detect

@err@
identifier conn, net, faddr, out, trans, loop_trans, is_outgoing;
position p;
@@

__rds_conn_create(struct net *net, ...,
		  const struct in6_addr *faddr, ...,
		  int is_outgoing, ...)
{
	...
*	conn->c_path = kcalloc(...);
	...
	loop_trans = rds_trans_get_preferred(net, faddr, conn->c_dev_if);
	if (loop_trans) {
		...
		if (trans->t_prefer_loopback) {
			if (likely(is_outgoing)) {
				...
			} else {
				... when != kfree(conn->c_path);
*				kmem_cache_free@p(..., conn);
				...
*				goto out;
			}
		}
	}
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2021-45480')
