/// Files: drivers/nfc/st21nfca/se.c
/// Fix: 4fbcc1a4cb20fe26ad0225679c536c80f1648221
/// Detect-To: 26fc6c7f02cb26c39c4733de3dbc3c0646fc1074

virtual detect

@err_aid exists@
identifier transaction, skb;
position p;
@@

st21nfca_connectivity_event_received(..., struct sk_buff *skb)
{
	... when != if (transaction->aid_len > sizeof(transaction->aid)) return ...;
*	memcpy@p(transaction->aid, ...);
	...
}

@err_params exists@
identifier transaction, skb;
position p;
@@

st21nfca_connectivity_event_received(..., struct sk_buff *skb)
{
	... when != if (transaction->params_len > ((skb->len - 2) - sizeof(struct nfc_evt_transaction))) return ...;
*	memcpy@p(transaction->params, ...);
	...
}

@script:python depends on detect@
p << err_aid.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-26490')

@script:python depends on detect@
p << err_params.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-26490')
